// This file was generated by createCFunction.sci on 13-03-2015 15:33

// Computational function for X2C block Atan2

#define MATLAB_MEX_FILE

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <Atan2_FiP16.h>
#include <Atan2_FiP16.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_Atan2_FiP16_C(scicos_block* block, scicos_flag flag);
static void x2c_Atan2_FiP16_C__OutputUpdate(scicos_block* block);
static void x2c_Atan2_FiP16_C__StateUpdate(scicos_block* block);
static void x2c_Atan2_FiP16_C__Initialization(scicos_block* block);
static void x2c_Atan2_FiP16_C__Ending(scicos_block* block);


void x2c_Atan2_FiP16_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_Atan2_FiP16_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_Atan2_FiP16_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_Atan2_FiP16_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_Atan2_FiP16_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_Atan2_FiP16_C__set_parameter(scicos_block* block, ATAN2_FIP16 *blockParam) {
    int *paramI;
    double *paramR;
    ATAN2_FIP16 *pTAtan2_FiP16;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTAtan2_FiP16 = GetWorkPtrs(block);
}


static void x2c_Atan2_FiP16_C__Initialization(scicos_block* block) {
    ATAN2_FIP16 *pTAtan2_FiP16;

    /* Declaration of inports */
    double *inport_y_p;
    int16 inport_y;
    double *inport_x_p;
    int16 inport_x;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTAtan2_FiP16 = scicos_malloc(sizeof(ATAN2_FIP16));
    GetWorkPtrs(block) = pTAtan2_FiP16;
    x2c_Atan2_FiP16_C__set_parameter(block, pTAtan2_FiP16);

    /* Assignment of inports */
    inport_y_p = GetInPortPtrs(block, 1);
    inport_y = (int16)( (*inport_y_p) * (double)((int16)1 << 15));
    pTAtan2_FiP16->y = &inport_y;
    inport_x_p = GetInPortPtrs(block, 2);
    inport_x = (int16)( (*inport_x_p) * (double)((int16)1 << 15));
    pTAtan2_FiP16->x = &inport_x;

    /* Initialization */
    Atan2_FiP16_Init(pTAtan2_FiP16);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = (double)pTAtan2_FiP16->Out / (double)((int16)1 << 15);
}


static void x2c_Atan2_FiP16_C__Ending(scicos_block* block) {
    ATAN2_FIP16 *pTAtan2_FiP16;
    pTAtan2_FiP16 = GetWorkPtrs(block);
    scicos_free(pTAtan2_FiP16);
}


static void x2c_Atan2_FiP16_C__StateUpdate_f(scicos_block* block) {
    ATAN2_FIP16 *pTAtan2_FiP16;

    /* Declaration of inports */
    double *inport_y_p;
    int16 inport_y;
    double *inport_x_p;
    int16 inport_x;

    /* *** */
    pTAtan2_FiP16 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_y_p = GetInPortPtrs(block, 1);
    inport_y = (int16)( (*inport_y_p) * (double)((int16)1 << 15));
    pTAtan2_FiP16->y = &inport_y;
    inport_x_p = GetInPortPtrs(block, 2);
    inport_x = (int16)( (*inport_x_p) * (double)((int16)1 << 15));
    pTAtan2_FiP16->x = &inport_x;

    /* Update */
    Atan2_FiP16_Update(pTAtan2_FiP16);
}


static void x2c_Atan2_FiP16_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_Atan2_FiP16_C__StateUpdate_f(block);
    }
}


static void x2c_Atan2_FiP16_C__OutputUpdate(scicos_block* block) {
    ATAN2_FIP16 *pTAtan2_FiP16;
    ATAN2_FIP16 tmpAtan2_FiP16;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTAtan2_FiP16 = GetWorkPtrs(block);

    /* Save work data */
    memcpy(&tmpAtan2_FiP16, pTAtan2_FiP16, sizeof(ATAN2_FIP16));

    /* *** */
    x2c_Atan2_FiP16_C__StateUpdate_f(block);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = (double)pTAtan2_FiP16->Out / (double)((int16)1 << 15);

    /* Copy back tmp data */
    memcpy(pTAtan2_FiP16, &tmpAtan2_FiP16, sizeof(ATAN2_FIP16));
}


