// This file was generated by createCFunction.sci on 13-03-2015 15:33

// Computational function for X2C block Div

#define MATLAB_MEX_FILE

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <Div_Float32.h>
#include <Div_Float32.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_Div_Float32_C(scicos_block* block, scicos_flag flag);
static void x2c_Div_Float32_C__OutputUpdate(scicos_block* block);
static void x2c_Div_Float32_C__StateUpdate(scicos_block* block);
static void x2c_Div_Float32_C__Initialization(scicos_block* block);
static void x2c_Div_Float32_C__Ending(scicos_block* block);


void x2c_Div_Float32_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_Div_Float32_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_Div_Float32_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_Div_Float32_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_Div_Float32_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_Div_Float32_C__set_parameter(scicos_block* block, DIV_FLOAT32 *blockParam) {
    int *paramI;
    double *paramR;
    DIV_FLOAT32 *pTDiv_Float32;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTDiv_Float32 = GetWorkPtrs(block);
}


static void x2c_Div_Float32_C__Initialization(scicos_block* block) {
    DIV_FLOAT32 *pTDiv_Float32;

    /* Declaration of inports */
    double *inport_In1_p;
    float32 inport_In1;
    double *inport_In2_p;
    float32 inport_In2;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTDiv_Float32 = scicos_malloc(sizeof(DIV_FLOAT32));
    GetWorkPtrs(block) = pTDiv_Float32;
    x2c_Div_Float32_C__set_parameter(block, pTDiv_Float32);

    /* Assignment of inports */
    inport_In1_p = GetInPortPtrs(block, 1);
    inport_In1 = (float32)( (*inport_In1_p) * (double)1.0);
    pTDiv_Float32->In1 = &inport_In1;
    inport_In2_p = GetInPortPtrs(block, 2);
    inport_In2 = (float32)( (*inport_In2_p) * (double)1.0);
    pTDiv_Float32->In2 = &inport_In2;

    /* Initialization */
    Div_Float32_Init(pTDiv_Float32);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = (double)pTDiv_Float32->Out / (double)1.0;
}


static void x2c_Div_Float32_C__Ending(scicos_block* block) {
    DIV_FLOAT32 *pTDiv_Float32;
    pTDiv_Float32 = GetWorkPtrs(block);
    scicos_free(pTDiv_Float32);
}


static void x2c_Div_Float32_C__StateUpdate_f(scicos_block* block) {
    DIV_FLOAT32 *pTDiv_Float32;

    /* Declaration of inports */
    double *inport_In1_p;
    float32 inport_In1;
    double *inport_In2_p;
    float32 inport_In2;

    /* *** */
    pTDiv_Float32 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_In1_p = GetInPortPtrs(block, 1);
    inport_In1 = (float32)( (*inport_In1_p) * (double)1.0);
    pTDiv_Float32->In1 = &inport_In1;
    inport_In2_p = GetInPortPtrs(block, 2);
    inport_In2 = (float32)( (*inport_In2_p) * (double)1.0);
    pTDiv_Float32->In2 = &inport_In2;

    /* Update */
    Div_Float32_Update(pTDiv_Float32);
}


static void x2c_Div_Float32_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_Div_Float32_C__StateUpdate_f(block);
    }
}


static void x2c_Div_Float32_C__OutputUpdate(scicos_block* block) {
    DIV_FLOAT32 *pTDiv_Float32;
    DIV_FLOAT32 tmpDiv_Float32;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTDiv_Float32 = GetWorkPtrs(block);

    /* Save work data */
    memcpy(&tmpDiv_Float32, pTDiv_Float32, sizeof(DIV_FLOAT32));

    /* *** */
    x2c_Div_Float32_C__StateUpdate_f(block);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = (double)pTDiv_Float32->Out / (double)1.0;

    /* Copy back tmp data */
    memcpy(pTDiv_Float32, &tmpDiv_Float32, sizeof(DIV_FLOAT32));
}


